## mingw-w64-gxml-0.20.4-4.src.tar.zst

=== meson_options.txt ===
option('introspection', type : 'boolean', value : true, description : 'Create GObject Introspection file definitions')
option('docs', type : 'boolean', value : true, description : 'Generate Vala Documentation')
option('experimental', type : 'boolean', value : false, description : 'Generate experimental classes')

=== test/valgrind/Makefile ===
VALAC=valac
VALAFLAGS=-g --save-temps --vapidir=../../gxml --pkg gxml
CC=gcc
CFLAGS=-g `pkg-config --cflags --libs glib-2.0 gobject-2.0 gxml gio-2.0`
C_PROGS=unlink_unattached_nodes small2a small2b gfile gobject document document_create_minimal libxml2 document_create_minimal_2 message

all: $(C_PROGS) example attributes small small2 scope supp

example: example.vala
	$(VALAC) $(VALAFLAGS) example.vala -o example

attributes: attributes.vala
	$(VALAC) $(VALAFLAGS) attributes.vala -o attributes

small: small.vala
	$(VALAC) $(VALAFLAGS) small.vala -o small

small2: small2.vala
	$(VALAC) $(VALAFLAGS) small2.vala -o small2

scope: scope.vala
	$(VALAC) $(VALAFLAGS) scope.vala -o scope

clean:
	rm example small small2 scope attributes $(C_PROGS) *~ \#*\#

runnew:
	(cd ../.. && make && make install); make clean; make
	make run

# we compile it for users of GXml
supp: *.supp
	cat *.supp > ../../gxml.supp

# use this like 'make run SUBJECT=./attributes'
run: all
	G_SLICE=always-malloc valgrind --leak-check=full --show-reachable=yes --suppressions=libxml2.supp --suppressions=gio.supp --suppressions=gtype.supp --suppressions=glib.supp --num-callers=40 ${SUBJECT}

run_nosupp:
	G_SLICE=always-malloc valgrind --leak-check=full --show-reachable=yes --num-callers=40 ./document

=== PKGBUILD ===
# Maintainer: Daniel Espinosa <esodan@gmail.com>

_realname=gxml
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=0.20.4
pkgrel=4
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
pkgdesc="GObject Libxml2 wrapper and Serializer Framework (mingw-w64)"
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-gettext"
         "${MINGW_PACKAGE_PREFIX}-glib2"
         "${MINGW_PACKAGE_PREFIX}-libgee"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-meson"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-vala"
             "${MINGW_PACKAGE_PREFIX}-gobject-introspection"
             "${MINGW_PACKAGE_PREFIX}-cc")
license=('spdx:LGPL-2.1-or-later')
url="https://wiki.gnome.org/GXml"
source=("https://gitlab.gnome.org/GNOME/gxml/-/archive/${pkgver}/gxml-${pkgver}.tar.gz")
sha256sums=('237f5d3984b6aa7378bfa030b7dadfad43041720f097bb5b4104e84829d741a5')
msys2_repository_url="https://gitlab.gnome.org/GNOME/gxml"

prepare() {
  cd "${srcdir}"/${_realname}-${pkgver}
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  # clang error from vala generated file
  export CFLAGS="${CFLAGS} -Wno-incompatible-function-pointer-types"

  MSYS2_ARG_CONV_EXCL="--prefix=" \
  ${MINGW_PREFIX}/bin/meson setup \
    --prefix="${MINGW_PREFIX}" \
    --buildtype plain \
    ../${_realname}-${pkgver}

  meson compile
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR="${pkgdir}" meson install

  for pcfile in  "${pkgdir}${MINGW_PREFIX}"/lib/pkgconfig/*.pc; do
    # make sure everything is derived from prefix
    sed -s "s|${MINGW_PREFIX}/|\${prefix}/|g" -i "${pcfile}"
  done

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
